﻿using System;
using System.Runtime.CompilerServices;
using System.Threading.Tasks;

namespace ConsoleApp2
{
    // 
    // ConsoleApp1 예제에서 CallAsync 메서드의 async를 해제
    //

    class Program
    {
        static void Main(string[] args)
        {
            Program pg = new Program();
            Task task = pg.CallAsync();

            task.GetAwaiter().GetResult();
        }

        private Task CallAsync()
        {
            CallAsync_1 stateMachine = new CallAsync_1
            {
                _this = this,
                _builder = AsyncTaskMethodBuilder.Create(),
                _state = -1,
            };

            stateMachine._builder.Start(ref stateMachine);
            return stateMachine._builder.Task;
        }

        private async Task<string> GetFileContents()
        {
            return await new TaskFactory().StartNew(() => { return "test"; });
        }

        class CallAsync_1 : IAsyncStateMachine
        {
            public int _state; // 1
            public AsyncTaskMethodBuilder _builder;
            public Program _this; // 4

            string _result; // 3
            string _returnResult;

            string _title;

            TaskAwaiter<string> _awaiter;

            void IAsyncStateMachine.MoveNext()
            {
                int num = this._state;

                try
                {
                    TaskAwaiter<string> awaiter;
                    switch (num)
                    {
                        case 0:
                            awaiter = this._awaiter;
                            this._awaiter = new TaskAwaiter<string>();
                            this._state = num = -1;
                            break;

                        default:
                            this._title = DateTime.Now.ToString();

                            awaiter = _this.GetFileContents().GetAwaiter();
                            if (awaiter.IsCompleted == false)
                            {
                                this._state = num = 0;
                                this._awaiter = awaiter;
                                CallAsync_1 stateMachine = this;
                                this._builder.AwaitUnsafeOnCompleted(ref awaiter, ref stateMachine);
                                return;
                            }
                            break;
                    }

                    this._result = awaiter.GetResult();
                    this._returnResult = this._result;
                    this._result = null;
                    Console.WriteLine(_title + ": " + this._returnResult);
                }
                catch (Exception e)
                {
                    this._state = -2;
                    this._builder.SetException(e);
                    return;
                }

                this._state = -2;
                this._builder.SetResult();
            }

            void IAsyncStateMachine.SetStateMachine(IAsyncStateMachine stateMachine)
            {
            }
        }
    }

}
